<?php
class Admin_model extends CI_Model {

	function __construct() {
		$this->load->database();
	}

	function getCourses() {
		$query = $this->db->get('courses');
		return $query->result();
	}

	function addCourse($cid, $name){
		$data = array(
			'cid' => $cid ,
			'name' => $name
		);

		$this->db->insert('courses', $data); 
		mkdir("../courses/".$cid);

	}

	function getExamples($cid) {
		$query = $this->db->get_where('examples', array("cid" => $cid));
		return $query->result();
	}

	function addExample($cid, $example){
		$data = array(
			'cid' => $cid ,
			'example' => $example
		);

		$this->db->insert('examples', $data); 
		mkdir("../courses/".$cid."/".$example);

	}

	function getPages($cid, $example) {
		$query = $this->db->get_where('pages', array("cid" => $cid, "example" => $example));
		return $query->result();
	}

	function addPage($cid, $example, $page, $documentation){
		$data = array(
			'cid' => $cid ,
			'example' => $example,
			'page' => $page ,
			'documentation' => $documentation 
		);

		$this->db->insert('pages', $data); 
		mkdir("../courses/".$cid."/".$example."/".$page);

	}

	function updatePage($cid, $example, $page, $documentation){
		$data = array(
			'documentation' => $documentation 
		);

		$this->db->where('cid', $cid);
		$this->db->where('example', $example);
		$this->db->where('page', $page);
		$this->db->update('pages', $data); 
	}

	function uploadFile($files, $cid, $example, $page){
		if(move_uploaded_file($files['tmp_name'], "../courses/".$cid."/".$example."/".$page."/".$files['name'])){
			echo json_encode(array('status'=>'File was uploaded successfuly!'));
		}	
	}
}
