﻿<?php 
$duggaPageName="johan_dugga_datorgrafik_1_transforms.php";
$courseName="DA133G Webbutveckling - datorgrafik G1N, 7,5hp (IKI)";
$courseOccasion="HT-12 LP1";
$duggaNr=3;
include "../../../../php/dugga_checklogin.php";

if ($accountname=checklogin($errorMsg, $courseName, $courseOccasion, $duggaNr)): ?>
<html>
	<head>
		<meta charset="UTF-8"/>			
		<script type="text/javascript" src="../../../../js/jquery.js"></script>	
		<script lang='Javascript'>
			var account="<?php echo $accountname ?>";		
					var duggaNr="<?php echo $duggaNr ?>";		
					var courseName="<?php echo $courseName ?>";		
					var courseOccasion="<?php echo $courseOccasion ?>";	
					
					$(document).ready(function() {
						fetchQuiz();
						fetchQuizObject("ObjDesc");
					});
					
					//login, courseName, courseOccasion, quizNr
					function fetchQuiz(){
						console.log("post fetchQuiz ");
						$.post("../quizAjax/getQuiz.php", 
							   {loginName: account, courseName: courseName, courseOccasion: courseOccasion, quizNr: duggaNr }, 
								fetchQuizCallBack,
								"json"
						);
					}
					
					function fetchQuizCallBack(data){
						console.log(data);
						if (typeof data.Error != 'undefined') {
							$("#result").append("<br/><h3>Error:"+data.Error+"</h3>");
						} else {
							$("#result").append("<br/>Dugga nr:"+data.quizNr);
							$("#result").append("<br/>Kursnamn:"+data.quizCourseName);
							$("#result").append("<br/>Lista över dugga-objekt:"+data.quizObjectIDs);
							$("#result").append("<br/>Data:"+data.quizData);
						}
					}
					
					//Kontrollera om inskickat svar är rätt (alternativt bara spara det om duggan inte rättas automatiskt) 
					function checkAnswer(submitstr){
						$.post("../quizAjax/answerQuiz.php", 
							{loginName: account, courseName: courseName, courseOccasion: courseOccasion, quizNr: duggaNr, quizAnswer: submitstr}, 
							checkAnswerCallBack,
							"json"
						);
					}
					
					function checkAnswerCallBack(data){
						console.log("checkAnswerCallBack:");
						console.log(data);
						if (typeof data.Error != 'undefined') {
							$("#result").append("<br/><h3>Error:"+data.Error+"</h3>");
						} else {
							for (var key in data) {
							  $("#result").append("<br />"+data[key]);
							}
						}
					}
					
					//Hämta ett dugga objekt (objekt id:n hämtas från listan med objekt id:n som kommer med duggan)
					//////Parameters: (POST) objectID, courseName, courseOccasion, quizNr, loginName
					function fetchQuizObject(objectName){
						console.log("post fetchQuizObject");
						$.post("../quizAjax/getQuizObject.php", 
							   {objectID: objectName, courseName: courseName, courseOccasion: courseOccasion, quizNr: duggaNr, loginName: account}, 
								fetchQuizObjectCallBack,
								"json"
						);
					}

					function fetchQuizObjectCallBack(data){
						if (typeof data.Error != 'undefined') {
							$("#result").append("<br/><h3>Error:"+data.Error+"</h3>");
						} else {
							$("#result").append(data.objectData);
						}
					}
		</script>
	
		<script type="text/javascript" src="../../../../js/dugga.js"></script>	
	
	<script lang='Javascript'>
				
		function newbutton()
		{
				var funclist;
				var oplist;
				
				funclist=document.getElementById('function');
				oplist=document.getElementById('operations');
				
				oplist.innerHTML+="<option value='"+funclist.options[funclist.selectedIndex].value+"'>"+funclist.options[funclist.selectedIndex].text+"</option>";
								
		}
		
		function deletebutton()
		{
				var elSel = document.getElementById('operations');
  			var i=0;
  			for (i=elSel.length-1;i>=0;i--) {
    				if (elSel.options[i].selected) {
      				elSel.remove(i);
    				}
  			}
		}
		
		function moveupbutton()
		{
				var elSel = document.getElementById('operations');
				var ind=elSel.selectedIndex;
				var val;
				var tex;

				if(elSel.selectedIndex>0){
						
						val=elSel.options[ind].value;
						tex=elSel.options[ind].text;

						elSel.options[ind].value=elSel.options[ind-1].value;
						elSel.options[ind].text=elSel.options[ind-1].text;
						
						elSel.options[ind-1].value=val;
						tex=elSel.options[ind-1].text=tex;
							
						elSel.selectedIndex--;				
				}
		}

		function movedownbutton()
		{
				var elSel = document.getElementById('operations');
				var ind=elSel.selectedIndex;
				var val;
				var tex;

				if(elSel.selectedIndex<elSel.length-1){
						
						val=elSel.options[ind].value;
						tex=elSel.options[ind].text;

						elSel.options[ind].value=elSel.options[ind+1].value;
						elSel.options[ind].text=elSel.options[ind+1].text;
						
						elSel.options[ind+1].value=val;
						tex=elSel.options[ind+1].text=tex;
							
						elSel.selectedIndex++;				
				}
				
		}

		function submbutton()
		{
				var submitstr="";
				
				var elSel = document.getElementById('operations');
  			var i=0;
  			
  			for (i=elSel.length-1;i>=0;i--) {
    				submitstr+=elSel.options[i].value; 
  			}				
		
				alert(submitstr);
			checkAnswer(submitstr);
		}

		function handler_mouseup()
		{
				clickstate=0;
		}
		
		function handler_mousedown()
		{
				clickstate=1;
		}
		
		function handler_mousemove (cx,cy) 
		{
				// Make use of cx and cy... right now no use as this app does not use clicks
		}
				
		var v=0;

		function foo()
		{
				acanvas.width = acanvas.width;				
				
				v+=0.1;

				context.translate(300,300);
				context.save(); 
				                
				var elSel = document.getElementById('operations');
  			var i=0;
  			for (i=0;i<=elSel.length-1;i++) {
						if(elSel.options[i].value=="T1"){
									context.translate(100,0);
						}if(elSel.options[i].value=="T2"){
									context.translate(150,0);
						}if(elSel.options[i].value=="T3"){
									context.translate(200,0);
						}if(elSel.options[i].value=="RP"){
									context.rotate(v);
						}if(elSel.options[i].value=="RN"){
									context.rotate(-v);
						}if(elSel.options[i].value=="S1"){
									context.scale(0.25,0.25);
						}if(elSel.options[i].value=="S2"){
									context.scale(0.5,0.5);
						}if(elSel.options[i].value=="S3"){
									context.scale(0.75,0.75);
						}if(elSel.options[i].value=="S4"){
									context.scale(1.5,1.5);
						}if(elSel.options[i].value=="D1"){
								drawball(0,0,40,30,10,"#f84",45.0,22.5);
						}if(elSel.options[i].value=="D2"){
								drawball(0,0,40,30,10,"#4f8",45.0,22.5);
						}if(elSel.options[i].value=="D3"){
								drawball(0,0,40,30,10,"#84f",45.0,22.5);
						}
  			}

  			

				// Must count saves
				// Restore equal amount of times
				
/*
				context.beginPath();
				drawcircle(40,'#f0f');
				
				context.lineWidth   = 0.5;

				context.moveTo(0,0);
				context.rect(0,0,30,30);

				context.stroke();
*/
				context.restore();
				context.globalAlpha = 0.5				
				context.rotate(-v*0.6);								
				drawsun();

				setTimeout("foo();",100);
				
	  }	  
					
	</script>

	</head>
	<body onload="setupcanvas();">
	<div id="result"></div>
	<table>
		<tr>
			<td>
				<canvas id='a' width='600' height='600' style='border:2px solid black;'>
				</canvas>
			</td>
			<td valign="top">
				<div style="border:2px solid black;background-color:#fed;width:300;height:450;">
					<div id="infobox" style="padding:4px;">
					Change values in form to update curve and information box.<br>

					<form>
					
					Function: 
					<select id="function" name="function" >

							<option value="T1">Translate 1</option>
							<option value="T2">Translate 2</option>
							<option value="T3">Translate 3</option>
							<option value="T4">Translate 4</option>
							<option value="RP">Rotate +</option>
							<option value="RN">Rotate -</option>
							<option value="S1">Scale 0.25</option>
							<option value="S2">Scale 0.50</option>
							<option value="S3">Scale 1.00</option>
							<option value="S4">Scale 2.00</option>
							<option value="S5">Scale 3.00</option>
							<option value="S6">Scale 4.00</option>
							<option value="D1">Draw R</option>
							<option value="D2">Draw G</option>
							<option value="D3">Draw B</option>

					</select>			
					<button type="button" onclick="newbutton();">NEW</button>
					
					<br>Operations:<br> 
					<select style="width:150px;" size="20" id="operations" name="operations">
					</select>			
					
					<br>
					<button type="button" onclick="moveupbutton();">MOVE UP</button>
					<button type="button" onclick="movedownbutton();">MOVE DOWN</button>
					<button type="button" onclick="deletebutton();">DELETE</button>
					<br>
					<button type="button" onclick="submbutton();">SUBMIT</button>
					<br>							
					</form>		

					</div>
				</div>
			</td>			
		</tr>
	</table>	

	<br>

	</div>

	</body>
</html>

<?php 

else:
    include "../../../../php/dugga_loginwindow.php";
endif;

?>

